<?php namespace App\Controllers\Configuracion;


use App\Controllers\BaseResourceController;

use App\Models\Collection;

use App\Entities\Configuracion\MaquinasDefectoEntity;

use App\Models\Configuracion\MaquinaModel;

use App\Models\Configuracion\MaquinasDefectoModel;

class Maquinasdefecto extends \App\Controllers\BaseResourceController
{

    protected $modelName = MaquinasDefectoModel::class;
    protected $format = 'json';

    protected static $singularObjectName = 'Maquina Por Defecto';
    protected static $singularObjectNameCc = 'maquinaPorDefecto';
    protected static $pluralObjectName = 'Maquinas Por Defecto';
    protected static $pluralObjectNameCc = 'maquinasPorDefecto';

    protected static $controllerSlug = 'maquinasdefecto';

    protected static $viewPath = 'themes/vuexy/form/configuracion/maquinas/';

    protected $indexRoute = 'maquinaPorDefectoList';


    public function initController(\CodeIgniter\HTTP\RequestInterface $request, \CodeIgniter\HTTP\ResponseInterface $response, \Psr\Log\LoggerInterface $logger)
    {
        $this->viewData['pageTitle'] = lang('MaquinasPorDefecto.moduleTitle');
        $this->viewData['usingSweetAlert'] = true;

        // Se indica que este controlador trabaja con soft_delete
        $this->soft_delete = true;
        // Se indica el flag para los ficheros borrados
        $this->delete_flag = 1;

        parent::initController($request, $response, $logger);
    }


    public function index()
    {

        $viewData = [
            'currentModule' => static::$controllerSlug,
            'pageSubTitle' => lang('Basic.global.ManageAllRecords', [lang('MaquinasPorDefecto.maquinaPorDefecto')]),
            'maquinasDefectoEntity' => new MaquinasDefectoEntity(),
            'usingServerSideDataTable' => true,

        ];

        $viewData = array_merge($this->viewData, $viewData); // merge any possible values from the parent controller class

        return view(static::$viewPath . 'viewMaquinaPorDefectoList', $viewData);
    }


    public function add()
    {


        

        if ($this->request->getPost()) :

            $nullIfEmpty = true; // !(phpversion() >= '8.1');

            $postData = $this->request->getPost();

            $sanitizedData = $this->sanitized($postData, $nullIfEmpty);

            // JJO
            $sanitizedData['user_created_id'] = auth()->user()->id;

            $noException = true;
            if ($successfulResult = $this->canValidate()) : // if ($successfulResult = $this->validate($this->formValidationRules) ) :

                if ($this->canValidate()) :
                    // JJO: se añade que se checkeen los intervalos de ancho y tirada.
                    // En caso de error se devuelve un mensaje.
                    try {
                        $error = $this->model->checkIntervals($sanitizedData);
                        if (empty($error)) {
                            $successfulResult = $this->model->skipValidation(true)->save($sanitizedData);
                        } else {
                            $successfulResult = false;
                            $this->viewData['errorMessage'] = $error;
                            $this->session->setFlashdata('formErrors', $this->model->errors());
                        }
                    } catch (\Exception $e) {
                        $noException = false;
                        $this->dealWithException($e);
                    }
                else:
                    $this->viewData['errorMessage'] = lang('Basic.global.formErr1', [lang('Basic.global.record')]);
                    $this->session->setFlashdata('formErrors', $this->model->errors());
                endif;

                $thenRedirect = true;  // Change this to false if you want your user to stay on the form after submission
            endif;
            if ($noException && $successfulResult) :

                $id = $this->model->db->insertID();

                $message = lang('Basic.global.saveSuccess', [lang('Basic.global.record')]) . '.';

                if ($thenRedirect) :
                    if (!empty($this->indexRoute)) :
                        return redirect()->to(route_to($this->indexRoute))->with('sweet-success', $message);
                    else:
                        return $this->redirect2listView('sweet-success', $message);
                    endif;
                else:
                    $this->session->setFlashData('sweet-success', $message);
                endif;

            endif; // $noException && $successfulResult

        endif; // ($requestMethod === 'post')

        $this->viewData['maquinasDefectoEntity'] = isset($sanitizedData) ? new MaquinasDefectoEntity($sanitizedData) : new MaquinasDefectoEntity();
        $this->viewData['maquinaList'] = $this->getMaquinaListItems($maquinasDefectoEntity->maquina_id ?? null);
        $this->viewData['tipoList'] = $this->getTipoOptions();

        $this->viewData['formAction'] = route_to('createMaquinaPorDefecto');

        $this->viewData['boxTitle'] = lang('Basic.global.addNew') . ' ' . lang('MaquinasPorDefecto.moduleTitle') . ' ' . lang('Basic.global.addNewSuffix');


        return $this->displayForm(__METHOD__);
    } // end function add()

    public function edit($requestedId = null)
    {


        if ($requestedId == null) :
            return $this->redirect2listView();
        endif;
        $id = filter_var($requestedId, FILTER_SANITIZE_URL);
        $maquinasDefectoEntity = $this->model->find($id);

        if ($maquinasDefectoEntity == false) :
            $message = lang('Basic.global.notFoundWithIdErr', [mb_strtolower(lang('MaquinasPorDefecto.maquinaPorDefecto')), $id]);
            return $this->redirect2listView('sweet-error', $message);
        endif;

        

        if ($this->request->getPost()) :

            $nullIfEmpty = true; // !(phpversion() >= '8.1');

            $postData = $this->request->getPost();

            $sanitizedData = $this->sanitized($postData, $nullIfEmpty);

            // JJO
            $sanitizedData['user_updated_id'] = auth()->user()->id;

            $noException = true;
            if ($successfulResult = $this->canValidate()) : // if ($successfulResult = $this->validate($this->formValidationRules) ) :

                if ($this->canValidate()) :
                    // JJO: se añade que se checkeen los intervalos de ancho y tirada.
                    // En caso de error se devuelve un mensaje.
                    try {
                        $error = $this->model->checkIntervals($sanitizedData, $id);
                        if (empty($error)) {
                            $successfulResult = $this->model->skipValidation(true)->update($id, $sanitizedData);
                        } else {
                            $successfulResult = false;
                            $this->viewData['errorMessage'] = $error;
                            $this->session->setFlashdata('formErrors', $this->model->errors());
                        }
                    } catch (\Exception $e) {
                        $noException = false;
                        $this->dealWithException($e);
                    }
                else:
                    $this->viewData['warningMessage'] = lang('Basic.global.formErr1', [mb_strtolower(lang('MaquinasPorDefecto.maquinaPorDefecto'))]);
                    $this->session->setFlashdata('formErrors', $this->model->errors());

                endif;

                $maquinasDefectoEntity->fill($sanitizedData);

                $thenRedirect = false;
            endif;
            if ($noException && $successfulResult) :
                $id = $maquinasDefectoEntity->id ?? $id;
                $message = lang('Basic.global.updateSuccess', [lang('Basic.global.record')]) . '.';

                if ($thenRedirect) :
                    if (!empty($this->indexRoute)) :
                        return redirect()->to(route_to($this->indexRoute))->with('sweet-success', $message);
                    else:
                        return $this->redirect2listView('sweet-success', $message);
                    endif;
                else:
                    $this->session->setFlashData('sweet-success', $message);
                endif;

            endif; // $noException && $successfulResult
        endif; // ($requestMethod === 'post')

        $this->viewData['maquinasDefectoEntity'] = $maquinasDefectoEntity;
        $this->viewData['maquinaList'] = $this->getMaquinaListItems($maquinasDefectoEntity->maquina_id ?? null);
        $this->viewData['tipoList'] = $this->getTipoOptions();

        $this->viewData['formAction'] = route_to('updateMaquinaPorDefecto', $id);

        $this->viewData['boxTitle'] = lang('Basic.global.edit2') . ' ' . lang('MaquinasPorDefecto.moduleTitle') . ' ' . lang('Basic.global.edit3');


        return $this->displayForm(__METHOD__, $id);
    } // end function edit(...)


    public function datatable()
    {
        if ($this->request->isAJAX()) {
            $reqData = $this->request->getPost();
            if (!isset($reqData['draw']) || !isset($reqData['columns'])) {
                $errstr = 'No data available in response to this specific request.';
                $response = $this->respond(Collection::datatable([], 0, 0, $errstr), 400, $errstr);
                return $response;
            }
            $start = $reqData['start'] ?? 0;
            $length = $reqData['length'] ?? 5;
            $search = $reqData['search']['value'];
            $requestedOrder = $reqData['order']['0']['column'] ?? 1;
            $requestedOrder2 = $reqData['order']['1']['column'] ?? $requestedOrder;
            $order = MaquinasDefectoModel::SORTABLE[$requestedOrder >= 0 ? $requestedOrder : 0];
            $order2 = MaquinasDefectoModel::SORTABLE[$requestedOrder2 >= 0 ? $requestedOrder2 : 0];
            $dir = $reqData['order']['0']['dir'] ?? 'asc';
            $dir2 = $reqData['order']['1']['dir'] ?? $dir;

            $resourceData = $this->model->getResource($search)->orderBy($order, $dir)->orderBy($order2, $dir2)->limit($length, $start)->get()->getResultObject();

            return $this->respond(Collection::datatable(
                $resourceData,
                $this->model->getResource()->countAllResults(),
                $this->model->getResource($search)->countAllResults()
            ));
        } else {
            return $this->failUnauthorized('Invalid request', 403);
        }
    }

    public function allItemsSelect()
    {
        if ($this->request->isAJAX()) {
            $onlyActiveOnes = true;
            $reqVal = $this->request->getPost('val') ?? 'id';
            $menu = $this->model->getAllForMenu($reqVal . ', tipo', 'tipo', $onlyActiveOnes, false);
            $nonItem = new \stdClass;
            $nonItem->id = '';
            $nonItem->tipo = '- ' . lang('Basic.global.None') . ' -';
            array_unshift($menu, $nonItem);

            $newTokenHash = csrf_hash();
            $csrfTokenName = csrf_token();
            $data = [
                'menu' => $menu,
                $csrfTokenName => $newTokenHash
            ];
            return $this->respond($data);
        } else {
            return $this->failUnauthorized('Invalid request', 403);
        }
    }

    public function menuItems()
    {
        if ($this->request->isAJAX()) {
            $searchStr = goSanitize($this->request->getPost('searchTerm'))[0];
            $reqId = goSanitize($this->request->getPost('id'))[0];
            $reqText = goSanitize($this->request->getPost('text'))[0];
            $onlyActiveOnes = false;
            $columns2select = [$reqId ?? 'id', $reqText ?? 'tipo'];
            $onlyActiveOnes = false;
            $menu = $this->model->getSelect2MenuItems($columns2select, $columns2select[1], $onlyActiveOnes, $searchStr);
            $nonItem = new \stdClass;
            $nonItem->id = '';
            $nonItem->text = '- ' . lang('Basic.global.None') . ' -';
            array_unshift($menu, $nonItem);

            $newTokenHash = csrf_hash();
            $csrfTokenName = csrf_token();
            $data = [
                'menu' => $menu,
                $csrfTokenName => $newTokenHash
            ];
            return $this->respond($data);
        } else {
            return $this->failUnauthorized('Invalid request', 403);
        }
    }


    protected function getMaquinaListItems($selId = null)
    {
        $data = ['' => lang('Basic.global.pleaseSelectA', [mb_strtolower(lang('Maquinas.maquina'))])];
        if (!empty($selId)) :
            $maquinaModel = model('App\Models\Configuracion\MaquinaModel');

            $selOption = $maquinaModel->where('id', $selId)->findColumn('nombre');
            if (!empty($selOption)) :
                $data[$selId] = $selOption[0];
            endif;
        endif;
        return $data;
    }


    protected function getTipoOptions()
    {
        $tipoOptions = [
            '' => lang('Basic.global.pleaseSelect'),
            'bn' => 'bn',
            'bnhq' => 'bnhq',
            'color' => 'color',
            'portada' => 'portada',
            'cubierta' => 'cubierta',
            'rotativa' => 'rotativa',
        ];
        return $tipoOptions;
    }


    //sanitiezdata
    //array(10) { ["tipo"]=> string(2) "bn" ["ancho_min"]=> string(3) "100" ["alto_min"]=> string(3) "180" ["tirada_min"]=> string(2) "31" ["maquina_id"]=> string(2) "80" ["ancho_max"]=> string(3) "477" ["alto_max"]=> string(3) "316" ["tirada_max"]=> string(5) "10000" ["save"]=> string(7) "Guardar" ["user_updated_id"]=> string(1) "1" } 
}
